"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class File(ProtocolElement):
    """
    This defines a file     This Record is defined by the sampleID and a
    URI     Currently SampleID can be a single String or an array of
    strings if multiple samples are associated with the same file
    *
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "fileType",
        "uriFile",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_4_0_0 import reports as reports_4_0_0

        return {
            "fileType": reports_4_0_0.FileType,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_4_0_0 import reports as reports_4_0_0

        return {
            "org.gel.models.report.avro.FileType": reports_4_0_0.FileType,
            "org.gel.models.report.avro.File": reports_4_0_0.File,
        }

    __slots__ = [
        "fileType",
        "uriFile",
        "md5Sum",
        "sampleId",
    ]

    def __init__(
        self,
        fileType,
        uriFile,
        md5Sum=None,
        sampleId=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_4_0_0.File model.

        :param fileType:
        :type fileType: FileType
        :param uriFile:
            URI PATH
        :type uriFile: str
        :param md5Sum:
        :type md5Sum: None | str
        :param sampleId:
            Unique ID(s) of the Sample, for example in a multisample vcf this
            would have an array of all the sample ids
        :type sampleId: None | list[str]
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "4.0.0"
